/*
 * FrontEndo for TErminal
 * Zaurus SL꡼ΥߥʥǤܸϤ򥵥ݡȤץࡣ
 * λ ToyEdit 򸵤˺
 *
 * Copyright (c) 2002 HIGAKI, Kenji <kaze@yk.rim.or.jp>
 *
 * ToyEdit original author:
 * Copyright (c) 2002 Hiroshi Okada <oka@kt.rim.or.jp>
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 *
 */

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.awt.datatransfer.*;

/**
 *  ¸뤿Υ֥
 */
class FeteParam implements Serializable {
  final static int FONT_SIZE = 10;  // ǥեȤΥեȥ
  final static int FRAME_W = 240;   // ǥեȤΥɥ
  final static int FRAME_H = 195; 

  int fontSize;
  int windowHeight;
  int windowWidth;

  /**
   * 󥹥ȥ饯
   * ե(~/.feterc)ɤ߹ࡣ
   * ɤ߹ߤ˼Ԥϥǥեͤꤹ롣
   */
  FeteParam() {
    try {
	  ObjectInputStream ois = new ObjectInputStream(new FileInputStream(System.getProperties().getProperty("user.home") + "/.feterc"));
	  FeteParam fp = (FeteParam)ois.readObject();
	  ois.close();
	  // ɤ߹֥Ȥͤ򥳥ԡ
	  fontSize = fp.fontSize;
	  windowHeight = fp.windowHeight;
	  windowWidth = fp.windowWidth;
	} catch (Exception e) {
	  fontSize = FONT_SIZE;
	  windowHeight = FRAME_H;
	  windowWidth = FRAME_W;
	}
  }

  /**
   * ͤ򥻡֤롣
   * 顼ϤȤꤢ̵뤹롣
   */
  void save() {
    try {
	  ObjectOutputStream oos = new ObjectOutputStream(new FileOutputStream(System.getProperties().getProperty("user.home") + "/.feterc"));
	  oos.writeObject(this);
	  oos.close();
	} catch (Exception e) {
	}
  }

  // եȥɤ߽񤭤᥽åɡ
  void setFontSize(int size) {
    fontSize = size;
  }
  int getFontSize() {
    return fontSize;
  }

  // ɥɤ߽񤭤᥽åɡ
  int getHeight() {
    return windowHeight;
  }
  int getWidth() {
    return windowWidth;
  }
  void setHeight(int height) {
    windowHeight = height;
  }
  void setWidth(int width) {
    windowWidth = width;
  }
  int getDefaultHeight() {
    return FRAME_H;
  }
  int getDefaultWidth() {
    return FRAME_W;
  }
}

/**
 *  Fete ץꥱΥᥤ󥯥饹
 */
public class Fete implements ActionListener,WindowListener{
  /*
   * 
   */
  final static String TITLE_HEAD = "Fete:";
    // ȥСɽƥȤƬ

  /*
   * ɽ륳ݡͥ
   */
  TextArea theTextArea;  
  Frame theFrame;

  final static int N_FONTS = 5;  // ǽʥեȤο
  CheckboxMenuItem fontSizeMenuItem[] = new CheckboxMenuItem[N_FONTS];

  // ɥ˻Ȥ
  Dialog dialog;
  // ǻȤƥȥեɡ⤵
  TextField tfWidth, tfHeight;

  // ѥ᡼ݻ륪֥ȡ
  FeteParam theFeteParam;

  // ǽʥեȥΥꥹȡ
  // ºݤˤϻȤʤΤäƤ뤬ġġ
  final static int fontSizeList[] = {10, 12, 14, 16, 18};

  /**
   * ĤΥ˥塼ƥ
   * f ʤ CheckboxMenuItem Ȥ롣
   */
  MenuItem createMenuItem(String label, String cmd, boolean f) {
    MenuItem mi;
    if (f) {
      mi = new CheckboxMenuItem(label, false);
	} else {
      mi = new MenuItem(label);
	}
    mi.addActionListener( this);
    mi.setActionCommand(cmd);
    return mi;
  }

  /**
   * ˥塼Сȥ˥塼ƥ롣
   */
  MenuBar createMenuBar() {
    MenuBar mb = new MenuBar();
	Menu m = new Menu("");

	m.add(createMenuItem("ɥ", "resizeDialog", false));

	Menu mf = new Menu("եȥ");
	// եȥλϥɥ˥塼ѡ
	for (int i = 0 ; i < N_FONTS ; i++) {
	  String s = Integer.toString(fontSizeList[i]);
	  mf.add(fontSizeMenuItem[i] = (CheckboxMenuItem)createMenuItem(s, "font" + s, true));
	}
	m.add(mf);

	mb.add(m);
	return mb;
  }

  /**
   * 
   * ݡͥȤꤹ
   */
  public void init() {
    theFrame = new Frame("Fete");
    theFrame.addWindowListener( this);

    // ƥȤϤ륨ꥢ롣
    theTextArea = new TextArea();
    theTextArea.setText("");
    theFrame.add( theTextArea);

    // ˥塼롣
	MenuBar mb = createMenuBar();
	theFrame.setMenuBar(mb);

    // ѥ᡼ɤ߹ࡣ
    theFeteParam = new FeteParam();

    // ɤ߹ѥ᡼˽
	// ɥȥեȤΥꤹ롣
    theFrame.setSize( theFeteParam.getWidth(), theFeteParam.getHeight());
    theFrame.show();
    theFrame.setSize( theFeteParam.getWidth(), theFeteParam.getHeight());
      // show ȤǤʤ setSize ʤ?
	setFontSize(theFeteParam.getFontSize());
  }

  /*
   * ٥ȤΥϥɥ
   */
  public void windowActivated( WindowEvent e) {
  }
  public void windowClosed( WindowEvent e) {
  }
  public void windowClosing( WindowEvent e) {
    doCommand( "quit");
  }
  /**
   * ɥ줿硣
   * ϥƥȤФ򥯥åץܡɤ롣
   * θƥȥꥢ
   * ʤФʤˤ⤻
   */
  public void windowDeactivated( WindowEvent e) {
    String s = theTextArea.getText();
	if (!s.equals("")) {
      StringSelection ss = new StringSelection( s);
      Clipboard c =  theTextArea.getToolkit().getSystemClipboard();
      c.setContents( ss, ss);
      theTextArea.setText("");
	}
  }
  public void windowDeiconified( WindowEvent e) {
  }
  public void windowIconified( WindowEvent e) {
  }
  public void windowOpened( WindowEvent e) {
  }  

  /**
   * եȥꤹ롣
   * ꤷͤե¸롣
   */
  public void setFontSize(int size) {
    // ߤΥեȤ򸵤˥ѤեȤꡢ
	// ˤäƥեȤꤹ롣
    Font f = theTextArea.getFont();
    String name = f.getName();
    int style = f.getStyle();
    f = new Font(name, style, size);	// 10, 12, 14, 16, 18
    theTextArea.setFont(f);

	// ꤵ줿ΤΤߥåĤ褦ˡ
    // ˥塼ΥåܥåĴ롣
	for (int i = 0 ; i < 5 ; i++) {
	  if (fontSizeList[i] == size) {
	    fontSizeMenuItem[i].setState(true);
	  } else {
	    fontSizeMenuItem[i].setState(false);
	  }
	}

    // ѥ᡼֥Ȥ˥եȥΡ
	// θѥ᡼򥻡֤롣
	theFeteParam.setFontSize(size);
    theFeteParam.save();
  }

  /**
   * ɥѹ롣
   */
  public void doResize() {
    // ѥ᡼֥Ȥ˿Τƥ֡
    theFeteParam.setHeight(Integer.parseInt(tfHeight.getText()));
    theFeteParam.setWidth(Integer.parseInt(tfWidth.getText()));
    theFeteParam.save();

	// ä
	dialog.dispose();
	// ɥѹ
    theFrame.setSize( theFeteParam.getWidth(), theFeteParam.getHeight());
  }
  /**
   * ͤǥե᤹ͤ
   */
  public void setDefaultSize() {
    tfHeight.setText(Integer.toString(theFeteParam.getDefaultHeight()));
    tfWidth.setText(Integer.toString(theFeteParam.getDefaultWidth()));
  }
  /**
   * 󥻥롣äΤߡ
   */
  public void doCancel() {
    dialog.dispose();
  }
   
  /**
   * 󥤥٥Ȥä顢ޥɼ¹ԥ᥽åɤƤӽФ
   */
  public void actionPerformed( ActionEvent ae) {
    String cmd = ae.getActionCommand();
    doCommand( cmd);
  }

  /**
   * ޥɼ¹ԥ᥽å
   * ޥɤˤäƤΥ֥ȤŬڤʥ᥽åɤƤӽФ
   */
  public void doCommand( String cmd) {
    if( cmd.equals( "quit")) {
      doQuit();
    } else if( cmd.equals("font10")) {
	  setFontSize(10);
    } else if( cmd.equals("font12")) {
	  setFontSize(12);
    } else if( cmd.equals("font14")) {
	  setFontSize(14);
    } else if( cmd.equals("font16")) {
	  setFontSize(16);
    } else if( cmd.equals("font18")) {
	  setFontSize(18);
    } else if( cmd.equals("resizeDialog")) {
	  popupResizeDialog();
    } else if( cmd.equals("resize")) {
	  doResize();
    } else if( cmd.equals("default")) {
	  setDefaultSize();
    } else if( cmd.equals("cancel")) {
	  doCancel();
    }
  }

  /**
   * ɥѤΥ롣
   */
  void popupResizeDialog() {
    dialog = new Dialog(theFrame, "Resize", true);
	Panel p = new Panel(); // ʤ?
	dialog.add(p);
	Panel p2 = new Panel(new GridLayout(2, 2));
	p2.add(new Label(""));
	p2.add(tfWidth = new TextField(Integer.toString(theFeteParam.getWidth()), 4));
	p2.add(new Label("⤵"));
	p2.add(tfHeight = new TextField(Integer.toString(theFeteParam.getHeight()), 4));
	p.add(p2);

	p2 = new Panel();
	Button b = new Button("");
	b.setActionCommand("resize");
    b.addActionListener(this);
	p2.add(b);
	b = new Button("");
	b.setActionCommand("default");
    b.addActionListener(this);
	p2.add(b);
    b = new Button("");
	b.setActionCommand("cancel");
    b.addActionListener(this);
	p2.add(b);
	p.add(p2);

	dialog.setResizable(false);
	dialog.setSize(130, 86);
	// ƥɥ̤֡
	dialog.setLocation(theFeteParam.getWidth() / 2 - (130 / 2), theFeteParam.getHeight() / 2 - (86 / 2));
	dialog.setVisible(true);
  }

  /**
   * λ
   */
  public void doQuit() {
    System.exit(0);
  }

  /**
   * ץ೫ϥ᥽å
   * 󥹥󥹤Ƽ¹Ԥ
   */
  public static void main( String[] argv) {
    Fete fe = new Fete();
    fe.init();
  }
}
